
// c++ build   ּ ó Ͻÿ. ------------------------------- //
#include "stdafx.h"
// ----------------------------------------------------------------------------------- //

#if defined(__BCPLUSPLUS__)  // Borland C++ Builder specific
#include <vcl.h>
#pragma hdrstop
#endif

#include <windows.h>

#define _DLL_MAIN_CPP_
#include "ComiDXSDK.h"

#ifdef __cplusplus
extern "C"{
#endif

typedef struct{
	char *name;
	FARPROC* ptr;
}LIB_FUNCT;

static HINSTANCE hLibrary=NULL;
#define __DLL_FILE_FULL_PATH__  _T("ComiDXDll.DLL")

t_bool DX_LoadDll(void)
{
	LIB_FUNCT Func[] = {
		//////////////////////////////////////////////////////////////////////////
		// Global Functions
		{"DX_GnLoadDevice", 					(FARPROC*)&DX_GnLoadDevice 			},
		{"DX_GnIsDevLoaded",					(FARPROC*)&DX_GnIsDevLoaded			},
		{"DX_GnUnloadDevice",					(FARPROC*)&DX_GnUnloadDevice		},
		{"DX_GnGetDevInfo",					(FARPROC*)&DX_GnGetDevInfo			},

		//////////////////////////////////////////////////////////////////////////
		// Advanced Functions
		{"DX_AdvWriteData",					(FARPROC*)&DX_AdvWriteData			},
		{"DX_AdvReadData",					(FARPROC*)&DX_AdvReadData			},
		{"DX_AdvAdGetVolt",					(FARPROC*)&DX_AdvAdGetVolt			},
		{"DX_AdvWriteCalbGain_AD",			(FARPROC*)&DX_AdvWriteCalbGain_AD	},
		{"DX_AdvWriteCalbOffset_AD",		(FARPROC*)&DX_AdvWriteCalbOffset_AD	},
		{"DX_AdvWriteCalbGain_DA",			(FARPROC*)&DX_AdvWriteCalbGain_DA	},
		{"DX_AdvWriteCalbOffset_DA",		(FARPROC*)&DX_AdvWriteCalbOffset_DA	},
		{"DX_AdvReadCalbGain_AD",			(FARPROC*)&DX_AdvReadCalbGain_AD	},
		{"DX_AdvReadCalbOffset_AD",			(FARPROC*)&DX_AdvReadCalbOffset_AD	},
		{"DX_AdvReadCalbGain_DA",			(FARPROC*)&DX_AdvReadCalbGain_DA	},
		{"DX_AdvReadCalbOffset_DA",			(FARPROC*)&DX_AdvReadCalbOffset_DA	},

		//////////////////////////////////////////////////////////////////////////
		// DIO Functions
		{"DX_DioSetUsage",						(FARPROC*)&DX_DioSetUsage				},
		{"DX_DioGetUsage",						(FARPROC*)&DX_DioGetUsage			},
		{"DX_DiGetOne",							(FARPROC*)&DX_DiGetOne				},
		{"DX_DiGetAll",							(FARPROC*)&DX_DiGetAll					},
		{"DX_DoGetOne",						(FARPROC*)&DX_DoGetOne				},
		{"DX_DoGetAll",							(FARPROC*)&DX_DoGetAll					},
		{"DX_DoPutOne",						(FARPROC*)&DX_DoPutOne				},
		{"DX_DoPutAll",							(FARPROC*)&DX_DoPutAll					},
		{"DX_DioGetOne",						(FARPROC*)&DX_DioGetOne				},
		{"DX_DioGetAll",							(FARPROC*)&DX_DioGetAll					},

		//////////////////////////////////////////////////////////////////////////
		// Analog Input Functions
		{"DX_AdSetInputType",					(FARPROC*)&DX_AdSetInputType			},
		{"DX_AdGetInputType",					(FARPROC*)&DX_AdGetInputType		},
		{"DX_AdSetRange",						(FARPROC*)&DX_AdSetRange				},
		{"DX_AdGetRange",						(FARPROC*)&DX_AdGetRange				},
		{"DX_AdGetDigit",						(FARPROC*)&DX_AdGetDigit				},
		{"DX_AdGetVolt",						(FARPROC*)&DX_AdGetVolt				},
		{"DX_AdScale",							(FARPROC*)&DX_AdScale				},														
		{"DX_AdTableSet",							(FARPROC*)&DX_AdTableSet				},														
		//////////////////////////////////////////////////////////////////////////
		// AD Scan Functions
		{"DX_SyncADSet",				(FARPROC*)&DX_SyncADSet	        },
		{"DX_AdScanSetRange",				(FARPROC*)&DX_AdScanSetRange		},
		{"DX_AdScanGetRange",				(FARPROC*)&DX_AdScanGetRange		},
		{"DX_AdScanSetChannelList",			(FARPROC*)&DX_AdScanSetChannelList	},
		{"DX_AdScanSetTriggerMode",		(FARPROC*)&DX_AdScanSetTriggerMode	},
		{"DX_AdScanGetTriggerMode",		(FARPROC*)&DX_AdScanGetTriggerMode	},
		{"DX_AdScanStart",						(FARPROC*)&DX_AdScanStart				},
		{"DX_AdScanFilterStart",				(FARPROC*)&DX_AdScanFilterStart		},
		{"DX_AdScanStop",						(FARPROC*)&DX_AdScanStop				},
		{"DX_AdScanClear",						(FARPROC*)&DX_AdScanClear				},
		{"DX_AdScanGetFreq",					(FARPROC*)&DX_AdScanGetFreq			},
		{"DX_AdScanChangeFreq",				(FARPROC*)&DX_AdScanChangeFreq	},
		{"DX_AdScanGetCurCount",			(FARPROC*)&DX_AdScanGetCurCount	},
		{"DX_AdScanIsBufFull",					(FARPROC*)&DX_AdScanIsBufFull			},
		{"DX_AdScanResume",					(FARPROC*)&DX_AdScanResume			},
		{"DX_AdScanRetrChannelI2",			(FARPROC*)&DX_AdScanRetrChannelI2	},
		{"DX_AdScanRetrChannelF4",			(FARPROC*)&DX_AdScanRetrChannelF4	},
		{"DX_AdScanRetrChannelF8",			(FARPROC*)&DX_AdScanRetrChannelF8	},
		{"DX_AdScanRetrBlockI2",				(FARPROC*)&DX_AdScanRetrBlockI2		},
		{"DX_AdScanRetrBlockF4",				(FARPROC*)&DX_AdScanRetrBlockF4		},
		{"DX_AdScanRetrBlockF8",				(FARPROC*)&DX_AdScanRetrBlockF8		},
		{"DX_AdScanFilterConfig",				(FARPROC*)&DX_AdScanFilterConfig		},
		{"DX_AdScanGetMinMax",				(FARPROC*)&DX_AdScanGetMinMax		},
		{"DX_AdScanMinMaxClear",			(FARPROC*)&DX_AdScanMinMaxClear	},
		{"DX_AdScanScopeBlockF8",			(FARPROC*)&DX_AdScanScopeBlockF8	},
		//////////////////////////////////////////////////////////////////////////
		// Analog Output Functions
		{"DX_DaClear",							(FARPROC*)&DX_DaClear					},
		{"DX_DaSetRange",						(FARPROC*)&DX_DaSetRange				},
		{"DX_DaGetRange",						(FARPROC*)&DX_DaGetRange				},
		{"DX_DaOut",								(FARPROC*)&DX_DaOut					},

		//////////////////////////////////////////////////////////////////////////
		// Waveform Generation Functions
		{"DX_SyncWFMSet",				(FARPROC*)&DX_SyncWFMSet	        },
		{"DX_WfmStart",						(FARPROC*)&DX_WfmStart						},
		{"DX_WfmStop",						(FARPROC*)&DX_WfmStop						},

		//////////////////////////////////////////////////////////////////////////
		// CNT Functions
		{"DX_CntClear",							(FARPROC*)&DX_CntClear					},
		{"DX_CntSetClearMode",				(FARPROC*)&DX_CntSetClearMode		},
		{"DX_CntGetClearMode",				(FARPROC*)&DX_CntGetClearMode		},
		//{"DX_CntHold",							(FARPROC*)&DX_CntHold					},
		//{"DX_CntSetHoldMode",				(FARPROC*)&DX_CntSetHoldMode		},
		//{"DX_CntGetHoldMode",				(FARPROC*)&DX_CntGetHoldMode		},
		{"DX_CntSetFilter",						(FARPROC*)&DX_CntSetFilter				},
		{"DX_CntGetFilter",						(FARPROC*)&DX_CntGetFilter				},
		{"DX_CntSetConfig",						(FARPROC*)&DX_CntSetConfig			},
		{"DX_CntGetConfig",						(FARPROC*)&DX_CntGetConfig			},
		{"DX_CntStart",							(FARPROC*)&DX_CntStart					},
		{"DX_CntIsActive",						(FARPROC*)&DX_CntIsActive				},
		{"DX_CntStop",							(FARPROC*)&DX_CntStop					},
		{"DX_CntSetDefault",					(FARPROC*)&DX_CntSetDefault			},
		{"DX_CntGetDefault",					(FARPROC*)&DX_CntGetDefault			},
		{"DX_CntGetCount",						(FARPROC*)&DX_CntGetCount			},
		
		//////////////////////////////////////////////////////////////////////////
		// Pulse Generator Functions
		{"DX_PgSetConfig",						(FARPROC*)&DX_PgSetConfig				},
		{"DX_PgGetConfig",						(FARPROC*)&DX_PgGetConfig				},
		{"DX_PgSetInverse",						(FARPROC*)&DX_PgSetInverse			},
		{"DX_PgGetInverse",						(FARPROC*)&DX_PgGetInverse			},
		{"DX_PgStart",							(FARPROC*)&DX_PgStart					},
		{"DX_PgStop",							(FARPROC*)&DX_PgStop					},
		{"DX_PgIsActive",						(FARPROC*)&DX_PgIsActive				},

		//////////////////////////////////////////////////////////////////////////
		// Frequency Checker Functions
		{"DX_FcSetCounter",						(FARPROC*)&DX_FcSetCounter			},
		{"DX_FcStart",								(FARPROC*)&DX_FcStart					},
		{"DX_FcStop",								(FARPROC*)&DX_FcStop					},
		{"DX_FcGetFrequency",					(FARPROC*)&DX_FcGetFrequency			},
		{"DX_FcIsActive",							(FARPROC*)&DX_FcIsActive				},
		
		//////////////////////////////////////////////////////////////////////////
		// Encoder Counter Functions - Only DX501
		{"DX_EcSetConfig",						(FARPROC*)&DX_EcSetConfig				},
		{"DX_EcGetConfig",						(FARPROC*)&DX_EcGetConfig				},
		{"DX_EcFilterEnable",					(FARPROC*)&DX_EcFilterEnable			},
		{"DX_EcFilterDisable",					(FARPROC*)&DX_EcFilterDisable			},	
		{"DX_EcSetMaxCount",					(FARPROC*)&DX_EcSetMaxCount			},
		{"DX_EcGetMaxCount",					(FARPROC*)&DX_EcGetMaxCount			},
		{"DX_EcSetDefault",						(FARPROC*)&DX_EcSetDefault				},
		{"DX_EcGetDefault",						(FARPROC*)&DX_EcGetDefault				},
		{"DX_EcGetCount",						(FARPROC*)&DX_EcGetCount				},
		{"DX_EcZClearEnable",					(FARPROC*)&DX_EcZClearEnable			},
		{"DX_EcZClearDisable",					(FARPROC*)&DX_EcZClearDisable			},
		{"DX_EcZSetMaxCount",				(FARPROC*)&DX_EcZSetMaxCount		},
		{"DX_EcZGetMaxCount",				(FARPROC*)&DX_EcZGetMaxCount		},
		{"DX_EcZSetDefault",					(FARPROC*)&DX_EcZSetDefault			},
		{"DX_EcZGetDefault",					(FARPROC*)&DX_EcZGetDefault			},
		{"DX_EcZGetCount",						(FARPROC*)&DX_EcZGetCount			},
		{"DX_EcStart",							(FARPROC*)&DX_EcStart					},
		{"DX_EcStop",							(FARPROC*)&DX_EcStop					},
		{"DX_EcIsActive",							(FARPROC*)&DX_EcIsActive				},
		{"DX_EcClear",							(FARPROC*)&DX_EcClear					},

		//////////////////////////////////////////////////////////////////////////
		// Latch Functions - Only DX501
		{"DX_LtcSetMode",						(FARPROC*)&DX_LtcSetMode				},
		{"DX_LtcGetMode",						(FARPROC*)&DX_LtcGetMode				},
		{"DX_LtcStart",							(FARPROC*)&DX_LtcStart					},
		{"DX_LtcStop",							(FARPROC*)&DX_LtcStop					},
		{"DX_LtcIsActive",						(FARPROC*)&DX_LtcIsActive				},
		{"DX_LtcClear",							(FARPROC*)&DX_LtcClear					},
		{"DX_LtcGetDataCount",					(FARPROC*)&DX_LtcGetDataCount		},
		{"DX_LtcReadOneLatch",				(FARPROC*)&DX_LtcReadOneLatch		},
		{"DX_LtcReadAllLatch",					(FARPROC*)&DX_LtcReadAllLatch			},

		//////////////////////////////////////////////////////////////////////////
		// CMP Functions - Only DX501
		{"DX_CmpSetConfig",					(FARPROC*)&DX_CmpSetConfig			},
		{"DX_CmpGetConfig",					(FARPROC*)&DX_CmpGetConfig			},
		{"DX_CmpSetRegularData",				(FARPROC*)&DX_CmpSetRegularData	},
		{"DX_CmpGetRegularData",			(FARPROC*)&DX_CmpGetRegularData	},
		{"DX_CmpSetRandomData",			(FARPROC*)&DX_CmpSetRandomData	},
		{"DX_CmpGetRandomData",			(FARPROC*)&DX_CmpGetRandomData	},
		{"DX_CmpStart",							(FARPROC*)&DX_CmpStart					},
		{"DX_CmpStop",							(FARPROC*)&DX_CmpStop					},
		{"DX_CmpIsActive",						(FARPROC*)&DX_CmpIsActive				},
		{"DX_CmpClear",							(FARPROC*)&DX_CmpClear				},

		//////////////////////////////////////////////////////////////////////////
		// Interrupt Functions
		{"DX_IntHandlerSetup",					(FARPROC*)&DX_IntHandlerSetup		},
		{"DX_IntDiHandlerEnable",				(FARPROC*)&DX_IntDiHandlerEnable		},
		{"DX_IntCntHandlerEnable",			(FARPROC*)&DX_IntCntHandlerEnable	},
		{"DX_IntAdScanHandlerEnable",		(FARPROC*)&DX_IntAdScanHandlerEnable},
		{"DX_IntHandlerDisable",				(FARPROC*)&DX_IntHandlerDisable		},
		{"DX_IntAllDisable",						(FARPROC*)&DX_IntAllDisable				},
		{"DX_IntGetEnableState",				(FARPROC*)&DX_IntGetEnableState		},

		//////////////////////////////////////////////////////////////////////////
		// Error Functions
		{"DX_ErrGetLastErrorCode",			(FARPROC*)&DX_ErrGetLastErrorCode	},
		{"DX_ErrShowLastError",				(FARPROC*)&DX_ErrShowLastError		},

		//////////////////////////////////////////////////////////////////////////
		// Debug Log Functions
		{"DX_DLogSetup",						(FARPROC*)&DX_DLogSetup				},
		{"DX_DLogSetFilePath",					(FARPROC*)&DX_DLogSetFilePath			},
		{"DX_DLogAddComment",				(FARPROC*)&DX_DLogAddComment		},
		{"DX_DLogGetCurType",				(FARPROC*)&DX_DLogGetCurType		},
		{"DX_DLogGetCurLevel",				(FARPROC*)&DX_DLogGetCurLevel		},
		{"DX_DLogGetCurFilePath",				(FARPROC*)&DX_DLogGetCurFilePath	},

		//////////////////////////////////////////////////////////////////////////
		// Test Functions
		{"DX_CPUClear",						(FARPROC*)&DX_CPUClear						},
		{"DX_TestFunc",						(FARPROC*)&DX_TestFunc						},

		{NULL, NULL}
	};


	LIB_FUNCT *f;

	if((hLibrary = LoadLibrary (__DLL_FILE_FULL_PATH__)) == NULL)
	{
		OutputDebugString(_T("\n The ComiDX SDK DLL not found"));
		return FALSE;
	}

	f = &Func[0];
	while(f->ptr != NULL)
	{
		*(f->ptr) = GetProcAddress ((HMODULE)hLibrary, f->name);
		f++;
	}
	return TRUE;
}

void DX_UnloadDll(void)
{
	if(hLibrary){
		FreeLibrary(hLibrary);
		hLibrary = NULL;
	}
}

t_bool DX_IsDllLoaded(void)
{
	return !(hLibrary == NULL);
}

#ifdef __cplusplus
}
#endif